#include <stdarg.h> 
#include <string>

class CPLString : public std::string
{
public:


    CPLString(void) { printf("build(1) %p\n", this); }
    ~CPLString() { printf("finalize %p = '%s'\n", this, c_str()); }
    CPLString( const std::string &oStr ) : std::string( oStr ) { printf("build(2) %p\n", this); }
    CPLString( const char *pszStr ) :  std::string( pszStr ) { printf("build(3) %p\n", this); }

    operator const char* (void) const { return c_str(); }

    CPLString& Printf( const char *pszFormat, ... )
    {
        va_list args;

        char buffer[256];

        va_start( args, pszFormat );
        vsprintf( buffer, pszFormat, args );
        va_end( args );

        *this = buffer;

        return *this;
    }

};

void foo(const char* text)
{
    printf("text = %s\n", text);
}

const char* bar()
{
    return CPLString().Printf("bar");
}

int main(int argc, char* argv[])
{
    /* This is OK. Or, at least it seems to be OK */
    foo(CPLString().Printf("foo"));

    /* This is bad : the string supporting the text is destroyed at the end of bar() */
    /* We are reading freed memory ! */
    printf("text = %s\n", bar());

    return 0;
}
